%
% Search for gamma_opt
%

clear;
EPS=1e-6;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

gmin=input('Min gamma value = ');
gmax=input('Max gamma value = ');
xval=[];
yval=[];

[nw1,dw1,nw2,dw2,alpha,Npoints,amp,lw1,dlw,Lpoints]=data;
for gamma=gmin:(gmax-gmin)/Npoints:gmax,
%gamma;

a1=polyadd(conv(nw1,star(nw1)),-gamma^2*conv(dw1,star(dw1)));
b1=gamma^2*conv(dw1,star(dw1));

a2=polyadd(conv(nw2,star(nw2)),-gamma^2*conv(dw2,star(dw2)));
b2=gamma^2*conv(dw2,star(dw2));

A1=conv(a1,a2);
B1=conv(b1,b2);

A=polyadd(B1,-A1);
B=B1;

[dG,nG]=spec(A,B);

eta=roots(dw1);
n1=length(eta);
nF=conv(nG,poly(-eta));
dF=conv(dG,poly(eta));

beta=roots(a1);
beta=beta(find((real(beta)>EPS) | ((abs(real(beta))<=EPS) ...
          & (imag(beta)>0))));
l=length(alpha);

if length(beta) == n1,

   M=[];
   for k=1:n1,
       M=[M; beta(k).^[n1+l-1:-1:0] mn(beta(k))*polyval(nF,beta(k)) ...
          /polyval(dF,beta(k))*beta(k).^[n1+l-1:-1:0]];
   end;
   for k=1:l,
       M=[M; alpha(k).^[n1+l-1:-1:0] mn(alpha(k))*polyval(nF,alpha(k)) ...
          /polyval(dF,alpha(k))*alpha(k).^[n1+l-1:-1:0]];
   end;

   for k=1:n1,
       M=[M; (-beta(k)).^[n1+l-1:-1:0]*mn(beta(k))*polyval(nF,beta(k)) ...
          /polyval(dF,beta(k)) (-beta(k)).^[n1+l-1:-1:0]];
   end;
   for k=1:l,
       M=[M;(-alpha(k)).^[n1+l-1:-1:0]*mn(alpha(k))*polyval(nF,alpha(k)) ...
          /polyval(dF,alpha(k)) (-alpha(k)).^[n1+l-1:-1:0]];
   end;

   xval=[xval gamma];
   yval=[yval min(svd(M))];

else

    warning='Non-generic case and/or illegal GAMMA value'
    message='Press ENTER/RETURN to continue'
    pause;

end;

end;

clf;
plot(xval,abs(yval))
grid;
xlabel('gamma');
ylabel('smin(M)');
title('Optimal case');

yval=fliplr(yval);
xval=fliplr(xval);
[a,b]=min(yval);
gamma_min=xval(b)
