%
% Optimal controller
%

clear;
EPSSS=1e-6;

%
% gamma = gamma_opt
%

gamma=input('GAMMA_OPT = ');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[nw1,dw1,nw2,dw2,alpha,Npoints,amp,lw1,lw2,Lpoints,epsn]=data;

epsss=epsn;
wval=[];

a1=polyadd(conv(nw1,star(nw1)),-gamma^2*conv(dw1,star(dw1)));
b1=gamma^2*conv(dw1,star(dw1));

nE=a1;
dE=b1;

a2=polyadd(conv(nw2,star(nw2)),-gamma^2*conv(dw2,star(dw2)));
b2=gamma^2*conv(dw2,star(dw2));

A1=conv(a1,a2);
B1=conv(b1,b2);

A=polyadd(B1,-A1);
B=B1;

[dG,nG]=spec(A,B);

eta=roots(dw1);
n1=length(eta);
nF=conv(nG,poly(-eta));
dF=conv(dG,poly(eta));

beta=roots(a1);
beta=beta(find((real(beta)>EPSSS) | ((abs(real(beta))<=EPSSS) ...
          & (imag(beta)>0))));
l=length(alpha);

if length(beta) == n1

   M=[];
   for k=1:n1,
       M=[M; beta(k).^[n1+l-1:-1:0] mn(beta(k))*polyval(nF,beta(k)) ...
          /polyval(dF,beta(k))*beta(k).^[n1+l-1:-1:0]];
   end;
   for k=1:l,
       M=[M; alpha(k).^[n1+l-1:-1:0] mn(alpha(k))*polyval(nF,alpha(k)) ...
          /polyval(dF,alpha(k))*alpha(k).^[n1+l-1:-1:0]];
   end;

   for k=1:n1,
       M=[M; (-beta(k)).^[n1+l-1:-1:0]*mn(beta(k))*polyval(nF,beta(k)) ...
          /polyval(dF,beta(k)) (-beta(k)).^[n1+l-1:-1:0]];
   end;
   for k=1:l,
       M=[M;(-alpha(k)).^[n1+l-1:-1:0]*mn(alpha(k))*polyval(nF,alpha(k)) ...
          /polyval(dF,alpha(k)) (-alpha(k)).^[n1+l-1:-1:0]];
   end;

   eps1=epsss;
   epsss=epsn;
   [Muu,Suu,Vuu]=svd(M);
%   LL=null(M);
   LL=Vuu(:,length(M));
   if Suu(length(M),length(M)) < epsn,
      nL=LL(n1+l+1:2*(n1+l))
      dL=LL(1:n1+l)
      epsss=eps1;

      nL=real(nL);
      dL=real(dL);

      nF=nF
      dF=dF

       k=1;
       for lw=lw1:(lw2-lw1)/Lpoints:lw2,
           w=10^lw;
           wval=[wval w];
           s=i*w;
           c1(k)=polyval(nE,s)/polyval(dE,s);
           c2(k)=polyval(nF,s)/polyval(dF,s);
           c3(k)=polyval(nL,s)/polyval(dL,s);
           c(k)=c1(k)*c2(k)*c3(k)/(1+mn(s)*c2(k)*c3(k))*md(s)*No(s)^(-1);
           p(k)=P(s);
           S(k)=(1+p(k)*c(k))^(-1);
           T(k)=1-S(k);
           per(k)=norm([polyval(nw1,s)/polyval(dw1,s)*S(k); ...
                        polyval(nw2,s)/polyval(dw2,s)*T(k)]);
           cmag(k)=abs(c(k));
           cang(k)=angle(c(k));
           pcr(k)=real(1+p(k)*c(k));
           pci(k)=imag(1+p(k)*c(k));
           k=k+1;
       end;

       clf;
       semilogx(wval,per);    
       grid;
       xlabel('w');
       ylabel('norm([W1.S W2.T])');                  
       title('Optimal case');

       Min_per=min(per)
       Max_per=max(per)

       message='Press ENTER/RETURN to continue'
       pause;	   

       subplot(2,1,1);
       semilogx(wval,20*log10(cmag));
       grid;
       xlabel('w');
       ylabel('20log10(|C(jw)|)');
       title('Magnitude plot');

       subplot(2,1,2);
       semilogx(wval,cang*180/pi);
       grid;
       xlabel('w');
       ylabel('phase of C(jw)');
       title('Phase plot');

       message='Press ENTER/RETURN to continue'
       pause;

       subplot(1,1,1);
       plot(pcr,pci,pcr,-pci,'-.');
       hold;
       arrow(pcr(1),pci(1),pcr(10),pci(10));
       hold;
       grid;
       title('Plot of 1+P(jw)C(jw)');

   else
	warning = 'Incorrect GAMMA_OPT value'
   end;

else

    warning='Non-generic case and/or incorrect GAMMA_OPT value'

end;


