%
% Suboptimal controllers
%

clear;
EPS=1e-6;

%
% gamma = gamma_opt
%

gamma=input('RHO = ');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[nw1,dw1,nw2,dw2,alpha,Npoints,amp,lw1,lw2,Lpoints]=data;

a1=polyadd(conv(nw1,star(nw1)),-gamma^2*conv(dw1,star(dw1)));
b1=gamma^2*conv(dw1,star(dw1));

nE=a1;
dE=b1;

a2=polyadd(conv(nw2,star(nw2)),-gamma^2*conv(dw2,star(dw2)));
b2=gamma^2*conv(dw2,star(dw2));

A1=conv(a1,a2);
B1=conv(b1,b2);

A=polyadd(B1,-A1);
B=B1;

[dG,nG]=spec(A,B);

eta=roots(dw1);
n1=length(eta);
nF=conv(nG,poly(-eta));
dF=conv(dG,poly(eta));

beta=roots(a1);
beta=beta(find((real(beta)>EPS) | ((abs(real(beta))<=EPS) ...
          & (imag(beta)>0))));
l=length(alpha);

if length(beta) ==n1,

   M=[];
   for k=1:n1,
       M=[M; beta(k).^[n1+l:-1:0] mn(beta(k))*polyval(nF,beta(k)) ...
          /polyval(dF,beta(k))*beta(k).^[n1+l:-1:0]];
   end;
   for k=1:l,
       M=[M; alpha(k).^[n1+l:-1:0] mn(alpha(k))*polyval(nF,alpha(k)) ...
          /polyval(dF,alpha(k))*alpha(k).^[n1+l:-1:0]];
   end;

   for k=1:n1,
       M=[M; (-beta(k)).^[n1+l:-1:0]*mn(beta(k))*polyval(nF,beta(k)) ...
          /polyval(dF,beta(k)) (-beta(k)).^[n1+l:-1:0]];
   end;
   for k=1:l,
       M=[M;(-alpha(k)).^[n1+l:-1:0]*mn(alpha(k))*polyval(nF,alpha(k)) ...
          /polyval(dF,alpha(k)) (-alpha(k)).^[n1+l:-1:0]];
   end;

   M=[M; (polyval(a1,-amp)/polyval(b1,amp)+1)*polyval(nF,amp) ...
      /polyval(dF,amp)*mn(amp)*(-amp).^[n1+l:-1:0] (-amp).^[n1+l:-1:0]];
   M=[M; (-amp).^[n1+l:-1:0] zeros(1,n1+l+1)];

   C=[zeros(2*(n1+l)+1,1);1];
   LL=M\C;

   L1=LL(1:n1+l+1)
   L2=LL(n1+l+2:2*(n1+l+1))

   nF=nF
   dF=dF

   wval=[];
   k=1;
   for lw=lw1:(lw2-lw1)/Lpoints:lw2,
       w=10^lw;
       wval=[wval w];
       s=i*w;
       c1(k)=polyval(nE,s)/polyval(dE,s);
       c2(k)=polyval(nF,s)/polyval(dF,s);
       c3(k)=(polyval(L2,s)+(-1)^(n1+l)*polyval(L1,-s)*U(s));
       c3(k)=c3(k)/(polyval(L1,s)+(-1)^(n1+l)*polyval(L2,-s)*U(s));
       c(k)=c1(k)*c2(k)*c3(k)/(1+mn(s)*c2(k)*c3(k))*md(s)*No(s)^(-1);
       p(k)=P(s);
       S(k)=(1+p(k)*c(k))^(-1);
       T(k)=1-S(k);
       per(k)=norm([polyval(nw1,s)/polyval(dw1,s)*S(k); ...
                    polyval(nw2,s)/polyval(dw2,s)*T(k)]);
       cmag(k)=abs(c(k));
       cang(k)=angle(c(k));
       pcr(k)=real(1+p(k)*c(k));
       pci(k)=imag(1+p(k)*c(k));
       k=k+1;
   end;

   clg;
   semilogx(wval,per);    
   grid;
   xlabel('w');
   ylabel('norm([W1.S W2.T])');                  
   title('Suboptimal case');

   Max_per=max(per)

   message='Press ENTER/RETURN to continue'
   pause;

   subplot(2,1,1);
   semilogx(wval,20*log10(cmag));
   grid;
   xlabel('w');
   ylabel('20log10(|C(jw)|)');
   title('Magnitude plot');

   subplot(2,1,2);
   semilogx(wval,cang*180/pi);
   grid;
   xlabel('w');
   ylabel('phase of C(jw)');
   title('Phase plot');

   message='Press ENTER/RETURN to continue'
   pause;

   subplot(1,1,1);
   plot(pcr,pci,pcr,-pci,'-.');
   hold;
   arrow(pcr(1),pci(1),pcr(10),pci(10));
   hold;
   grid;
   title('Plot of 1+P(jw)C(jw)');

else

    warning = 'Non-generic case and/or illegal RHO value'

end;







